print("<<<Hp94's SafeChat loaded successfully.>>>")

table.insert(Command.Slash.Register("encrypt"), {function (params)
	print("Encrypted Result: "..MODIFY(params));
end, "SafeChat", "Slash command"})

table.insert(Command.Slash.Register("dencrypt"), {function (params)
	print("Dencrypted Result: "..UNMODIFY(params));
end, "SafeChat", "Slash command"})

table.insert(Command.Slash.Register("print"), {function (params)
	print(params);
end, "SafeChat", "Slash command"})

table.insert(Command.Slash.Register("ceasar"), {function (params)
	Alphabet()
	CeasarCipher1(params)
end, "SafeChat", "Slash command"})

table.insert(Command.Slash.Register("cipher"), {function (params)
	Alphabet()
	CeasarCipher2(params)
end, "SafeChat", "Slash command"})

table.insert(Command.Slash.Register("decipher"), {function (params)
	Alphabet()
	Decipher2(params)
end, "SafeChat", "Slash command"})

table.insert(Command.Slash.Register("safechat"), {function (params)
	print("<<<Welcome to SafeChat help!>>>")
	print("To encrypt using a basic cipher, type /encrypt text (Valid: a-z, A-Z, 0-9, !,@,#,$,%,^,&,*)")
	print("To dencrypt messages of this nature, type /dencrypt text (This only dencrypts text encrypted with the above method)")
	print("To use a basic Ceasar Cipher, type /ceasar text (Valid: a-z, A-Z). This command will also decipher texts encrypted with this Ceasar Cipher, because of how the encryption process works.")
	print("To use a non-basic Cipher, type /cipher text (Valid: a-z, A-Z). This command will use a special cipher to encrypt text. This is different than the above cipher, and must be deniphered with /decipher.")
	print("To decipher text that was modified with the above command, use /decipher text (Valid: a-z, A-Z).")
	print("<<<Need more help? Visit me as Hp94 on the RIFT forums, or email RIFTFanClub@Hotmail.ca.>>>")
end, "SafeChat", "Slash command"})

function Alphabet()

	upperCase = {"A", "B", "C", "D", "E", "F", "G", "H", "I", "J", "K", "L", "M", "N", "O", "P", "Q", "R", "S", "T", "U", "V", "W", "X", "Y", "Z", "A", "B", "C", "D", "E", "F", "G", "H", "I", "J", "K", "L", "M", "N", "O", "P", "Q", "R", "S", "T", "U", "V", "W", "X", "Y", "Z"};
	lowerCase = upperCase;
	
	for i=1, 52 do
		lowerCase[i] = string.lower(upperCase[i])
	end

end

function CeasarCipher1(intake)

	holdingValues = {};
	encryptedValues = {};

	for i=1, string.len(intake) do
		table.insert(holdingValues, string.sub(string.lower(intake), i, i))
	end
	
	for s=1, string.len(intake) do
		for i=1, 26 do
			proxyCompare = lowerCase[i];
			proxyReplace = lowerCase[i+13];
			proxyString = holdingValues[s];
			if proxyCompare == proxyString then
				table.insert(encryptedValues, proxyReplace)
			end
		end
	end
	
	print("Origin: "..intake);
	print("End Result: "..table.concat(encryptedValues));

	
end

function CeasarCipher2(intake)

	holdingValues = {};
	encryptedValues = {};

	for i=1, string.len(intake) do
		table.insert(holdingValues, string.sub(string.lower(intake), i, i))
	end
	
	for s=1, string.len(intake) do
		for i=1, 26 do
			proxyCompare = lowerCase[i];
			proxyReplace = lowerCase[i+12];
			proxyString = holdingValues[s];
			if proxyCompare == proxyString then
				table.insert(encryptedValues, proxyReplace)
			end
		end
	end
	
	print("Origin: "..intake);
	print("End Result: "..table.concat(encryptedValues));

	
end

function Decipher2(intake)

	holdingValues = {};
	encryptedValues = {};

	for i=1, string.len(intake) do
		table.insert(holdingValues, string.sub(string.lower(intake), i, i))
	end
	
	for s=1, string.len(intake) do
		for i=1, 26 do
			proxyCompare = lowerCase[i];
			proxyReplace = lowerCase[i+14];
			proxyString = holdingValues[s];
			if proxyCompare == proxyString then
				table.insert(encryptedValues, proxyReplace)
			end
		end
	end
	

	print("Origin: "..intake);
	print("End Result: "..table.concat(encryptedValues));
	
end

function MODIFY(intake)
	intake = string.lower(intake)
	intake = string.gsub(intake, "[z]", "}")
	intake = string.gsub(intake, "[x]", "{")
	intake = string.gsub(intake, "[c]", "A")
	intake = string.gsub(intake, "[v]", "B")
	intake = string.gsub(intake, "[b]", "C")
	intake = string.gsub(intake, "[n]", "D")
	intake = string.gsub(intake, "[m]", "&")
	intake = string.gsub(intake, "[a]", "F")
	intake = string.gsub(intake, "[s]", "G")
	intake = string.gsub(intake, "[d]", "H")
	intake = string.gsub(intake, "[f]", "I")
	intake = string.gsub(intake, "[g]", "J")
	intake = string.gsub(intake, "[h]", "K")
	intake = string.gsub(intake, "[j]", "@")
	intake = string.gsub(intake, "[k]", "L")
	intake = string.gsub(intake, "[l]", "M")
	intake = string.gsub(intake, "[q]", "N")
	intake = string.gsub(intake, "[w]", "O")
	intake = string.gsub(intake, "[e]", "#")
	intake = string.gsub(intake, "[r]", "P")
	intake = string.gsub(intake, "[t]", "Q")
	intake = string.gsub(intake, "[y]", "R")
	intake = string.gsub(intake, "[u]", "S")
	intake = string.gsub(intake, "[i]", "T")
	intake = string.gsub(intake, "[o]", "U")
	intake = string.gsub(intake, "[p]", "V")
	intake = string.gsub(intake, "[2]", "W")
	intake = string.gsub(intake, "[4]", "X")
	intake = string.gsub(intake, "[5]", "Y")
	intake = string.gsub(intake, "[3]", "Z")
	intake = string.gsub(intake, "[a]", ">")
	intake = string.gsub(intake, "[6]", "<")
	intake = string.gsub(intake, "[0]", ";")
	intake = string.gsub(intake, "[9]", ":")
	intake = string.gsub(intake, "[7]", "-")
	intake = string.gsub(intake, "[8]", "+")
	intake = string.gsub(intake, "%s", "E")
	return intake;
end

function UNMODIFY(intake)
	intake = string.gsub(intake, "[}]", "z")
	intake = string.gsub(intake, "[{]", "x")
	intake = string.gsub(intake, "[A]", "c")
	intake = string.gsub(intake, "[B]", "v")
	intake = string.gsub(intake, "[C]", "b")
	intake = string.gsub(intake, "[D]", "n")
	intake = string.gsub(intake, "[&]", "m")
	intake = string.gsub(intake, "[F]", "a")
	intake = string.gsub(intake, "[G]", "s")
	intake = string.gsub(intake, "[H]", "d")
	intake = string.gsub(intake, "[I]", "f")
	intake = string.gsub(intake, "[J]", "g")
	intake = string.gsub(intake, "[K]", "h")
	intake = string.gsub(intake, "[@]", "j")
	intake = string.gsub(intake, "[L]", "k")
	intake = string.gsub(intake, "[M]", "l")
	intake = string.gsub(intake, "[N]", "q")
	intake = string.gsub(intake, "[O]", "w")
	intake = string.gsub(intake, "[#]", "e")
	intake = string.gsub(intake, "[P]", "r")
	intake = string.gsub(intake, "[Q]", "t")
	intake = string.gsub(intake, "[R]", "y")
	intake = string.gsub(intake, "[S]", "u")
	intake = string.gsub(intake, "[T]", "i")
	intake = string.gsub(intake, "[U]", "o")
	intake = string.gsub(intake, "[V]", "p")
	intake = string.gsub(intake, "[W]", "2")
	intake = string.gsub(intake, "[X]", "4")
	intake = string.gsub(intake, "[Y]", "5")
	intake = string.gsub(intake, "[Z]", "3")
	intake = string.gsub(intake, "[>]", "a")
	intake = string.gsub(intake, "[<]", "6")
	intake = string.gsub(intake, "[;]", "0")
	intake = string.gsub(intake, "[:]", "9")
	intake = string.gsub(intake, "[-]", "7")
	intake = string.gsub(intake, "[+]", "8")
	intake = string.gsub(intake, "E", " ")
	return intake;
end



